package de.itstall;

import javax.swing.*;
import java.awt.*;
import java.awt.event.KeyListener;

public class GrafikBodymass extends JFrame {
	private JTextField tfGroesse, tfGewicht;
	private JButton btnBerechne, btnBeenden;
	private JLabel lblResultat, lblGewicht, lblGroesse, lblAnleitung;
	private JSlider slGroesse, slGewicht;

	public static void main(String[] args) {
		GrafikBodymass gbm = new GrafikBodymass();
		gbm.setVisible(true);
		gbm.tfGroesse.requestFocusInWindow();
	}

	public GrafikBodymass() {
		this.initializeComponents();
	}

	private void initializeComponents() {
		this.setTitle("BMI Rechner");
		this.setBounds(10,10,500,300);
		this.setResizable(false);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setLayout(null);

		/** Komponenten erzeugen */
		tfGroesse = new JTextField();
		tfGewicht = new JTextField();
		btnBerechne = new JButton();
		btnBeenden = new JButton();
		lblAnleitung = new JLabel();
		lblResultat = new JLabel();
		lblGewicht = new JLabel();
		lblGroesse = new JLabel();
		slGroesse = new JSlider();
		slGewicht = new JSlider();

		/** Beschriftungen setzen */
		lblAnleitung.setText("<html><center>Dieser Rechner berechnet deinen BMI.<br>Gib dzu dein Gewicht in kg und deine Größe in cm an.</center></html>");
		lblResultat.setText("Bitte zuerst berechnen lassen!!!");
		lblGroesse.setText("Größe");
		lblGewicht.setText("Gewicht");
		btnBerechne.setText("Berechnen");

		btnBeenden.setText("X");
		btnBeenden.setBackground(Color.RED);
		btnBeenden.setForeground(Color.BLACK);

		/** Größe und Position */
		btnBeenden.setBounds(440,0,50,40);
		lblAnleitung.setBounds(100,10, 400, 40);
		lblGroesse.setBounds(60, 70, 50, 20);
		tfGroesse.setBounds(115,70,100,20);
		tfGroesse.setText("160");
		lblGewicht.setBounds(240,70,50,20);
		tfGewicht.setBounds(300,70,100,20);
		tfGewicht.setText("80");
		btnBerechne.setBounds(200,120,100,20);
		lblResultat.setBounds(175,160,300,80);

		slGroesse.setBounds(55,90,165,20);
		slGroesse.setMinimum(1);
		slGroesse.setMaximum(250);
		slGroesse.setValue(160);

		slGewicht.setBounds(235, 90, 170, 20);
		slGewicht.setMinimum(1);
		slGewicht.setMaximum(250);
		slGewicht.setValue(80);

		this.add(lblAnleitung);
		this.add(lblResultat);
		this.add(lblGroesse);
		this.add(lblGewicht);
		this.add(btnBerechne);
		this.add(tfGewicht);
		this.add(tfGroesse);
		this.add(btnBeenden);
		this.add(slGroesse);
		this.add(slGewicht);

		btnBerechne.addActionListener(e -> berechne());
		btnBeenden.addActionListener(e -> System.exit(0));
		slGroesse.addChangeListener(e -> moveSlGroesse());
		slGewicht.addChangeListener(e -> moveSlGewicht());
	}

	public void moveSlGroesse() {
		tfGroesse.setText(String.valueOf(slGroesse.getValue()));
	}

	public void moveSlGewicht() {
		tfGewicht.setText(String.valueOf(slGewicht.getValue()));
	}

	public void berechne() {
		double bmi;

		Bodymass bodymass = new Bodymass();

		bmi = bodymass.berechneBmi((Double.valueOf(this.tfGewicht.getText())) , Double.valueOf(this.tfGroesse.getText()) / 100);
		this.lblResultat.setText("<html>Resultat:<br><br>BMI: " + bmi + "<br>Diagnose: " + bodymass.diagnose(bmi)+"</html>");
	}
}